data Peca = Vazio | Parede | Bloco Char
	  deriving Eq

instance Show Peca
    where showsPrec _ Vazio = showChar ' '
	  showsPrec _ Parede = showChar '#'
	  showsPrec _ (Bloco c) = showChar c

type Dimensao = Int

data Tabuleiro = Tabuleiro Dimensao Dimensao [[Peca]]
	       deriving Eq

nivel00 = Tabuleiro 10 8 
	   [[Parede,Parede,Parede,Parede,Parede,Parede,Parede,Parede],
	    [Parede,Parede,Parede,Parede,Parede,Parede,Parede,Parede],
	    [Parede,Parede,Parede,Parede,Parede,Parede,Parede,Parede],
	    [Parede,Parede,Bloco '1',Vazio,Parede,Bloco '2',Parede,Parede],
	    [Parede,Bloco '1',Vazio,Vazio,Parede,Bloco '1',Parede,Parede],
	    [Parede,Bloco '2',Vazio,Vazio,Vazio,Vazio,Parede,Parede],
	    [Parede,Parede,Bloco '2',Vazio,Vazio,Vazio,Parede,Parede],
	    [Parede,Parede,Parede,Parede,Parede,Parede,Parede,Parede],
	    [Parede,Parede,Parede,Parede,Parede,Parede,Parede,Parede],
	    [Parede,Parede,Parede,Parede,Parede,Parede,Parede,Parede]]

nivel02 = Tabuleiro 10 8 
	   [[Parede,Parede,Parede,Parede,Parede,Parede,Parede,Parede],
	    [Parede,Parede,Parede,Parede,Parede,Parede,Parede,Parede],
	    [Parede,Parede,Parede,Bloco '1',Bloco '2',Parede,Parede,Parede],
	    [Parede,Parede,Bloco '1',Vazio,Vazio,Vazio,Parede,Parede],
	    [Parede,Vazio,Vazio,Parede,Bloco '3',Vazio,Vazio,Parede],
	    [Parede,Vazio,Vazio,Parede,Bloco '1',Vazio,Vazio,Parede],
	    [Parede,Parede,Bloco '3',Vazio,Vazio,Vazio,Parede,Parede],
	    [Parede,Parede,Parede,Bloco '3',Bloco '2',Parede,Parede,Parede],
	    [Parede,Parede,Parede,Parede,Parede,Parede,Parede,Parede],
	    [Parede,Parede,Parede,Parede,Parede,Parede,Parede,Parede]]

nivel40 = Tabuleiro 10 8 
	   [[Parede,Parede,Parede,Parede,Parede,Parede,Parede,Parede],
	    [Parede,Parede,Parede,Parede,Parede,Parede,Parede,Parede],
	    [Parede,Parede,Bloco '1',Bloco '2',Bloco '1',Parede,Parede,Parede],
	    [Parede,Parede,Bloco '2',Bloco '3',Bloco '2',Bloco '4',Vazio,Parede],
	    [Parede,Bloco '2',Bloco '2',Vazio,Vazio,Vazio,Vazio,Parede],
	    [Parede,Parede,Bloco '2',Bloco '1',Bloco '4',Bloco '2',Bloco '3',Parede],
	    [Parede,Parede,Bloco '1',Bloco '2',Vazio,Parede,Bloco '2',Parede],
	    [Parede,Parede,Parede,Parede,Bloco '2',Parede,Parede,Parede],
	    [Parede,Parede,Parede,Parede,Parede,Parede,Parede,Parede],
	    [Parede,Parede,Parede,Parede,Parede,Parede,Parede,Parede]]

nivel57 = Tabuleiro 10 8
	   [[Parede,Parede,Parede,Parede,Parede,Parede,Parede,Parede],
	    [Parede,Parede,Parede,Parede,Parede,Parede,Parede,Parede],
	    [Parede,Parede,Parede,Vazio,Parede,Parede,Parede,Parede],
	    [Parede,Bloco '1',Bloco '2',Vazio,Vazio,Parede,Bloco '3',Parede],
	    [Parede,Bloco '4',Bloco '3',Bloco '1',Bloco '4',Vazio,Vazio,Parede],
	    [Parede,Parede,Parede,Bloco '5',Vazio,Vazio,Parede,Parede],
	    [Parede,Bloco '5',Bloco '4',Bloco '3',Bloco '5',Bloco '4',Parede,Parede],
	    [Parede,Bloco '3',Vazio,Vazio,Vazio,Vazio,Vazio,Parede],
	    [Parede,Bloco '5',Parede,Parede,Parede,Bloco '2',Bloco '5',Parede],
	    [Parede,Parede,Parede,Parede,Parede,Parede,Parede,Parede]]

type Posicao = (Dimensao,Dimensao)

pecaNaPosicao :: Tabuleiro -> Posicao -> Peca
pecaNaPosicao (Tabuleiro x y t) (x',y') | (x'>=0 && x'<x && y'>=0 && y'<y) = (t!!x')!!y'
				      	| otherwise = Parede
						    
pecasEliminaveis :: Tabuleiro -> [Posicao]
--pecasEliminaveis (Tabuleiro x y t) = [(x',y') | x'<-[0..(x-1)], y'<-[0..(y-1)], eliminavel (Tabuleiro x y t) (x',y')]
pecasEliminaveis (Tabuleiro _ _ t) = remDuplicates (pecasEliminaveisAux t 0)

pecasEliminaveisAux [] _ = []
pecasEliminaveisAux [_] _ = []
pecasEliminaveisAux (h1:h2:t) x = (pecasEliminaveisCol h1 h2 x 0)++(pecasEliminaveisAux (h2:t) (x+1))

pecasEliminaveisCol [] [] _ _ = []
pecasEliminaveisCol [_] [_] _ _ = []
pecasEliminaveisCol (a:b:t1) (c:d:t2) x y = (if ((eBloco a) && a==b) then [(x,y),(x,y+1)] else [])++(if ((eBloco c) && c==d) then [(x+1,y),(x+1,y+1)] else [])++(if ((eBloco a) && a==c) then [(x,y),(x+1,y)] else [])++(if ((eBloco b) && b==d) then [(x,y+1),(x+1,y+1)] else [])++(pecasEliminaveisCol (b:t1) (d:t2) x (y+1))
pecasEliminaveisCol (h1:t1) (h2:t2) x y = pecasEliminaveisCol t1 t2 x (y+1)

remDuplicates :: Eq a => [a] -> [a]
remDuplicates [] = []
remDuplicates (h:t) = h:(remDuplicates (filter (/= h) t))

eBloco :: Peca -> Bool
eBloco (Bloco _) = True
eBloco _ = False

eliminavel :: Tabuleiro -> Posicao -> Bool
eliminavel t (x,y) = (eBloco peca) && ((peca == (pecaNaPosicao t (x+1,y))) || (peca == (pecaNaPosicao t (x-1,y))) || (peca == (pecaNaPosicao t (x,y+1))) || (peca == (pecaNaPosicao t (x,y-1))))
		     where peca = pecaNaPosicao t (x,y)

pecasSuspensas :: Tabuleiro -> [Posicao]
pecasSuspensas (Tabuleiro x y t) = pecasSuspensasAux t 0

pecasSuspensasAux [] _ = []
pecasSuspensasAux (h:t) x = (pecasSuspensasCol h x 0)++(pecasSuspensasAux t (x+1))

pecasSuspensasCol [] _ _ = []
pecasSuspensasCol (Vazio:(Bloco _):t) x y = (x,y+1):(pecasSuspensasCol t x (y+2))
pecasSuspensasCol (h:t) x y = pecasSuspensasCol t x (y+1)

suspensa :: Tabuleiro -> Posicao -> Bool
suspensa t (x,y) = (eBloco peca) && ((pecaNaPosicao t (x,y-1))==Vazio)
		   where peca = pecaNaPosicao t (x,y)

correcto :: Tabuleiro -> Bool
correcto (Tabuleiro x y t) = ((length t)<=x) && (and (map ((<=y).length) t)) && (null (pecasSuspensas (Tabuleiro x y t))) && (null (pecasEliminaveis (Tabuleiro x y t)))

instance Show Tabuleiro
    where showsPrec _ (Tabuleiro _ _ t) = showString (unlines (map (map (head.show)) (reverse (transposta t))))

transposta :: [[a]] -> [[a]]
transposta m | and (map null m) = []
	     | otherwise = (map head m):(transposta (map tail m))

data Direccao = Esquerda | Direita
	      deriving (Eq,Show)

type Jogada = (Posicao,Direccao)

jogadaPossivel :: Tabuleiro -> Jogada -> Bool
jogadaPossivel t ((x,y),Esquerda) = (eBloco peca) && ((pecaNaPosicao t (x-1,y))==Vazio)
    where peca = pecaNaPosicao t (x,y)
jogadaPossivel t ((x,y),Direita) = (eBloco peca) && ((pecaNaPosicao t (x+1,y))==Vazio)
    where peca = pecaNaPosicao t (x,y)

substitui :: Tabuleiro -> Peca -> Posicao -> Tabuleiro
substitui (Tabuleiro x y t) p (x',y') = Tabuleiro x y (replaceAt t (replaceAt (t!!x') p y') x')

replaceAt :: [a] -> a -> Int -> [a]
replaceAt (h:t) x 0 = (x:t)
replaceAt (h:t) x (n+1) = h:(replaceAt t x n)

joga :: Tabuleiro -> Jogada -> Tabuleiro
joga t j = corrige (move t j)

move :: Tabuleiro -> Jogada -> Tabuleiro
move t ((x,y),Esquerda) = substitui (substitui t (pecaNaPosicao t (x,y)) (x-1,y)) Vazio (x,y)
move t ((x,y),Direita) = substitui (substitui t (pecaNaPosicao t (x,y)) (x+1,y)) Vazio (x,y)

corrige :: Tabuleiro -> Tabuleiro
corrige t | correcto t = t
	  | (not.null) (pecasSuspensas t) = corrige (foldr (\p t -> desce t p) t (pecasSuspensas t))
	  | otherwise = corrige (foldr (\p t -> substitui t Vazio p) t (pecasEliminaveis t))

desce :: Tabuleiro -> Posicao -> Tabuleiro
desce t (x,y) | suspensa t (x,y) = desce (substitui (substitui t (pecaNaPosicao t (x,y)) (x,y-1)) Vazio (x,y)) (x,y-1)
	      | otherwise = t


